## ecflow 5.13.8

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_CXX_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
##############################################################################

# need 3.12.0 as this has findBoost fix for the latest boost version 1.67
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

# ===========================================================================
# Change the default if NO CMAKE_BUILD_TYPE specified
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build Configuration type" FORCE)
endif()

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild /workspace/ecbuild) # Before project()

project( ecflow LANGUAGES CXX VERSION 5.13.8 )

# Important: the project version is used, as generated CMake variables, to filter .../ecflow/core/ecflow_version.h.in

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.6 )
include(CompilerOptions)

###############################################################################
# local project

ecbuild_declare_project()

ecbuild_info( "CMAKE_MODULE_PATH        : ${CMAKE_MODULE_PATH}")
ecbuild_info( "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}" )
ecbuild_info( "ecflow_BINARY_DIR        : ${ecflow_BINARY_DIR}" )
ecbuild_info( "ecflow_SOURCE_DIR        : ${ecflow_SOURCE_DIR}" )


# =========================================================================================
# Options , be aware of caching, when modifying on the command line. 
# Ideally start fresh or remove cache CmakeCache.txt in build dir
# =========================================================================================
option( ENABLE_SERVER              "Build the server, can be switched off if just building UI" ON  )
option( ENABLE_PYTHON              "enable python interface"         ON  )
option( ENABLE_UI                  "Build ecFlowUI"                  ON  ) 
option( ENABLE_STATIC_BOOST_LIBS   "Link with boost libs statically" ON  )
option( ENABLE_ALL_TESTS           "This includes performance/migration/regression tests" OFF )
option( ENABLE_UI_BACKTRACE        "Print a UI debug backtrace"         OFF ) 
option( ENABLE_UI_USAGE_LOG        "Enable UI usage logging"            OFF )
option( ENABLE_SSL                 "Enable SSL encrypted communication" ON )
option( ENABLE_PYTHON_PTR_REGISTER "Some compilers/boost versions do not register shared ptr automatically" OFF  )
option( ENABLE_HTTP                "Enable HTTP server (experimental)" ON  )
option( ENABLE_HTTP_COMPRESSION    "Enable compression support by HTTP server" ON )
option( ENABLE_UDP                 "Enable UDP server (experimental)" ON )
option( ENABLE_DOCS                "Enable Documentation" OFF )

include(Policies NO_POLICY_SCOPE)

# =========================================================================================
# Dependency: Qt
# =========================================================================================
# Qt for ecFlowUI.
# Algorithm: we test for Qt6 - if it's there, then use it; otherwise look for Qt5.
#            if we don't find that, then we cannot build ecFlowUI.
# -----------------------------------------------------------------------------------------
if(ENABLE_UI)

  ecbuild_info("")
  ecbuild_info("------------------------------ Qt start ---------------------------")
  ecbuild_info("ecFlowUI is enabled - searching for Qt6/Qt5")
  ecbuild_info("To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH")

  find_package(Qt6Widgets)
  if( Qt6Widgets_FOUND )
    find_package(Qt6Core5Compat  REQUIRED)
    find_package(Qt6Gui          REQUIRED)
    find_package(Qt6Network      REQUIRED)
    find_package(Qt6Svg          REQUIRED)
    find_package(Qt6Charts)

    ecbuild_debug("Qt6 version ${Qt6Widgets_VERSION_STRING} was found")
    set(ECFLOW_QT_INCLUDE_DIR ${Qt6Core5Compat_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Svg_INCLUDE_DIRS})
    set(ECFLOW_QT_LIBRARIES  ${Qt6Core5Compat_LIBRARIES} ${Qt6Widgets_LIBRARIES}    ${Qt6Gui_LIBRARIES}   ${Qt6Network_LIBRARIES} ${Qt6Svg_LIBRARIES})
    set(ECFLOW_QT6 1)
    add_definitions(-DECFLOW_QT6)

    if(Qt6Charts_FOUND)
      ecbuild_info("Qt6Charts was found - the server log viewer will be built")
      list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt6Charts_INCLUDE_DIRS})
      list(APPEND ECFLOW_QT_LIBRARIES  ${Qt6Charts_LIBRARIES})
      set(ECFLOW_LOGVIEW 1)
      add_definitions(-DECFLOW_LOGVIEW)
    else()
      ecbuild_info("Qt6Charts was not found - the server log viewer will not be built")
    endif()
  else()
    find_package(Qt5Widgets)
    if (Qt5Widgets_FOUND)
      find_package(Qt5Gui          REQUIRED)
      find_package(Qt5Network      REQUIRED)
      find_package(Qt5Svg          REQUIRED)
      find_package(Qt5Charts)

      ecbuild_info("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
      set(ECFLOW_QT_INCLUDE_DIR ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
      set(ECFLOW_QT_LIBRARIES   ${Qt5Widgets_LIBRARIES}    ${Qt5Gui_LIBRARIES}   ${Qt5Network_LIBRARIES} ${Qt5Svg_LIBRARIES})
      set(ECFLOW_QT5 1)
      add_definitions(-DECFLOW_QT5)

      if(Qt5Charts_FOUND)
        ecbuild_info("Qt5Charts was found - the server log viewer will be built")
        list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt5Charts_INCLUDE_DIRS})
        list(APPEND ECFLOW_QT_LIBRARIES  ${Qt5Charts_LIBRARIES})
        set(ECFLOW_LOGVIEW 1)
        add_definitions(-DECFLOW_LOGVIEW)
      else()
        ecbuild_info("Qt5Charts was not found - the server log viewer will not be built")
      endif()
    else()
      ecbuild_critical("Qt5 Widgets, Network and Gui not found - these are required for ecFlowUI; or use -DENABLE_UI=OFF")
    endif()
  endif()

  set(ECFLOW_QT 1)
  add_definitions(-DQT_NO_KEYWORDS) # We need to disable keywords because there is a problem in using Qt and boost together.
  ecbuild_info("------------------------------ Qt end----------------------------")
  ecbuild_info("")

endif()


# sanity check - cannot set ENABLE_UI_BACKTRACE if UI is OFF
if(ENABLE_UI_BACKTRACE AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot ENABLE_UI_BACKTRACE if UI is not enabled")
  set(ENABLE_UI_BACKTRACE OFF)
endif()

# sanity check - cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI and ENABLE_UI_BACKTRACE are OFF
if(UI_BACKTRACE_EMAIL_ADDRESS_FILE AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI is not enabled")
  set(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
endif()

# sanity check - cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is OFF
if(UI_LOG_FILE AND (NOT ENABLE_UI_USAGE_LOG))
  ecbuild_warn("Cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is not enabled")
  set(UI_LOG_FILE)
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_FILE))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT LOGUI_LOG_FILE))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, LOGUI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_SITE_TAG
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_SITE_TAG))
  ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_SITE_TAG must also be set")
endif()

# sanity check - cannot set UI_SYSTEM_SERVERS_LIST if UI IS OFF
if(UI_SYSTEM_SERVERS_LIST AND (NOT ENABLE_UI))
  ecbuild_warn("Cannot set UI_SYSTEM_SERVERS_LIST if UI is not enabled")
  set(UI_SYSTEM_SERVERS_LIST)
endif()

if(ENABLE_HTTP AND NOT ENABLE_SERVER)
  ecbuild_warn("ENABLE_SERVER is disabled, therefore HTTP_SERVER will also be disabled")
  set(ENABLE_HTTP OFF)
endif()

if(ENABLE_UDP AND NOT ENABLE_SERVER)
  ecbuild_warn("ENABLE_SERVER is disabled, therefore UDP_SERVER will also be disabled")
  set(ENABLE_UDP OFF)
endif()


ecbuild_info( "ENABLE_SERVER              : ${ENABLE_SERVER}" )
ecbuild_info( "ENABLE_PYTHON              : ${ENABLE_PYTHON}" )
ecbuild_info( "ENABLE_PYTHON_PTR_REGISTER : ${ENABLE_PYTHON_PTR_REGISTER}" )
ecbuild_info( "ENABLE_UI                  : ${ENABLE_UI}" )
ecbuild_info( "ENABLE_TESTS               : ${ENABLE_TESTS} *if* disabled no need for boost test libs" )
ecbuild_info( "ENABLE_ALL_TESTS           : ${ENABLE_ALL_TESTS}" )
ecbuild_info( "ENABLE_STATIC_BOOST_LIBS   : ${ENABLE_STATIC_BOOST_LIBS}" )
ecbuild_info( "ENABLE_SSL                 : ${ENABLE_SSL} *if* openssl libraries available" )
ecbuild_info( "ENABLE_HTTP                : ${ENABLE_HTTP}" )
ecbuild_info( "ENABLE_HTTP_COMPRESSION    : ${ENABLE_HTTP_COMPRESSION}" )
ecbuild_info( "ENABLE_UDP                 : ${ENABLE_UDP}" )


if (ENABLE_UI)
  ecbuild_info( "ENABLE_UI_BACKTRACE        : ${ENABLE_UI_BACKTRACE}" )
  if (UI_BACKTRACE_EMAIL_ADDRESS_FILE)
    ecbuild_info( "UI_BACKTRACE_EMAIL_ADDRESS_FILE : ${UI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
  endif()

  if(LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE)
    ecbuild_info( "LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE : ${LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
  endif()

  if(UI_SYSTEM_SERVERS_LIST)
    ecbuild_info( "UI_SYSTEM_SERVERS_LIST : ${UI_SYSTEM_SERVERS_LIST}" )
  endif()

  ecbuild_info( "ENABLE_UI_USAGE_LOG        : ${ENABLE_UI_USAGE_LOG}" )
  if(ENABLE_UI_USAGE_LOG)
    ecbuild_info( "UI_LOG_FILE                : ${UI_LOG_FILE}" )
    ecbuild_info( "LOGUI_LOG_FILE             : ${LOGUI_LOG_FILE}" )
    ecbuild_info( "UI_LOG_SITE_TAG            : ${UI_LOG_SITE_TAG}" )
  endif()
endif()
ecbuild_info("")


# =========================================================================================
# Setup Project-wide dependencies
# =========================================================================================
include(Dependencies)

# =========================================================================================
# Dependency: Boost
# =========================================================================================
message( STATUS "====================================================================================================================" )
message( STATUS "BOOST" )
# this can help in some situations:
set (_CMAKE_PREFIX_PATH_BACKUP ${CMAKE_PREFIX_PATH}) # make a backup of CMAKE_PREFIX_PATH
foreach(BOOST_PATH_TO_SEARCH ${BOOST_PATH} ${BOOST_ROOT} $ENV{BOOST_ROOT})
    ecbuild_debug("adding: ${BOOST_PATH_TO_SEARCH} to CMAKE_PREFIX_PATH")
    list(APPEND CMAKE_PREFIX_PATH ${BOOST_PATH_TO_SEARCH})
    list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endforeach()

# Ecflow test require statics libs for boost < 1.59, otherwise get double free error.
# To use static boost python ensure that Boost_USE_STATIC_LIBS is set on.
# See: http://www.cmake.org/cmake/help/v3.0/module/FindBoost.html
if ( ENABLE_STATIC_BOOST_LIBS )
    set(Boost_USE_STATIC_LIBS ON)
    ecbuild_info( "Using STATIC boost libraries : ${BOOST_TEST_DYN_LINK}" )
else()
    set(BOOST_TEST_DYN_LINK "BOOST_TEST_DYN_LINK")
    ecbuild_info( "Using SHARED boost libraries setting : ${BOOST_TEST_DYN_LINK}" )
endif()

# By default cmake assume boost was built with cmake. Hence looks for package config file BoostConfig.cmake/boost-config.cmake
# This seems to mess up the search for boost python libs.
# if Boost_NO_BOOST_CMAKE is not set, we seem to mess up in finding right python libs(python3 and python2), 
# for boost 1.71 and cmake 3.15 or greater
set(Boost_NO_BOOST_CMAKE ON) 

set(Boost_USE_MULTITHREADED  ON)

=== docs/requirements.txt ===
# These are the requirements for readthedoc
docutils
Sphinx>=4.4.0
setuptools>=51.0.0
sphinx-rtd-theme>=0.5.0

=== tools/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# This can be used by submission system. i.e trimurti
ecbuild_add_executable(
  TARGET
    ecflow_standalone
  SOURCES
    ecflow_standalone.c
)

#
# Configure  ecflow_site.sh. This is used in ecflow_start.sh and ecflow_stop.sh
# Used in coping with start of ecflow server on a linux cluser
# Avoid's hard copy mention of paths specific to ECMWF

if( DEFINED SITE_SPECIFIC_SERVER_SCRIPT )
  macro(install_symlink filepath sympath)
    install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${filepath} ${sympath})")
    install(CODE "message(\"-- Created symlink: ${sympath} -> ${filepath}\")")
  endmacro(install_symlink)
  
  install_symlink(${SITE_SPECIFIC_SERVER_SCRIPT} ${CMAKE_INSTALL_PREFIX}/bin/ecflow_site.sh )
endif()

install(
  FILES
    ${CMAKE_SOURCE_DIR}/tools/ecflow_fuse.py
    ${CMAKE_SOURCE_DIR}/tools/ecflow_logsvr.pl
    ${CMAKE_SOURCE_DIR}/tools/ecflow_start.sh
    ${CMAKE_SOURCE_DIR}/tools/ecflow_stop.sh
    ${CMAKE_SOURCE_DIR}/tools/ecflow_logserver.sh
  DESTINATION bin
  PERMISSIONS
    OWNER_READ
    OWNER_WRITE
    OWNER_EXECUTE
    GROUP_READ
    GROUP_EXECUTE
    WORLD_READ
    WORLD_EXECUTE
  COMPONENT
    binary
)

=== Viewer/libViewer/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

add_subdirectory( src )

=== libs/attribute/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(test_srcs
  # Sources
  test/TestAttributes_main.cpp
  test/TestAttrSerialization.cpp
  test/TestAvisoAttr.cpp
  test/TestCron.cpp
  test/TestDateAttr.cpp
  test/TestDayAttr.cpp
  test/TestLabel.cpp
  test/TestLateAttr.cpp
  test/TestMigration.cpp
  test/TestRepeat.cpp
  test/TestRepeatRange.cpp
  test/TestSizeOf.cpp
  test/TestTimeAttr.cpp
  test/TestTodayAttr.cpp
  test/TestVariable.cpp
  test/TestVariableMap.cpp
  test/TestZombieAttr.cpp
)

ecbuild_add_test(
  TARGET
    u_attributes
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    ../core/test
  LIBS
    ecflow_all
    test_scaffold
  TEST_DEPENDS
    u_core
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
)
target_clangformat(u_attributes
  CONDITION ENABLE_TESTS
)

=== libs/base/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(test_srcs
  # Headers
  test/MockServer.hpp
  test/TestHelper.hpp
  # Sources
  test/TestAlterCmd.cpp
  test/TestArchiveAndRestoreCmd.cpp
  test/TestBase_main.cpp # test entry point
  test/TestClientHandleCmd.cpp
  test/TestCmd.cpp
  test/TestDeleteNodeCmd.cpp
  test/TestForceCmd.cpp
  test/TestFreeDepCmd.cpp
  test/TestInLimitAndLimit.cpp
  test/TestLogCmd.cpp
  test/TestMeterCmd.cpp
  test/TestProgramOptions.cpp
  test/TestQueryCmd.cpp
  test/TestQueueCmd.cpp
  test/TestRequest.cpp
  test/TestRequeueNodeCmd.cpp
  test/TestResolveDependencies.cpp
  test/TestSpecificIssues.cpp
  test/TestSSyncCmd.cpp
  test/TestSSyncCmdOrder.cpp
  test/TestSSyncCmd_CH1.cpp
  test/TestStatsCmd.cpp
)

ecbuild_add_test(
  TARGET
    u_base
  LABELS
    unit nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    ../node/test
  LIBS
    ecflow_all
    Threads::Threads
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  TEST_DEPENDS
    u_parser
)
target_clangformat(u_base
  CONDITION ENABLE_TESTS
)

# The following is not technically a test (as it makes no checks),
# but a tool to measure the time it takes to generate a job file
if (ENABLE_ALL_TESTS)
  set(test_srcs
    # Sources
    test/TestJobGenPerf.cpp
  )

  ecbuild_add_test(
    TARGET
      p_job_gen
    LABELS
      performance
    SOURCES
      ${test_srcs}
    LIBS
      ecflow_all
      Threads::Threads
  )
  target_clangformat(p_job_gen
    CONDITION ENABLE_TESTS
  )
endif()

=== libs/client/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# ========================================================================
# EXE ecflow_client, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable(
  TARGET
    ecflow_client
  SOURCES
    src/ecflow/client/ClientMain.cpp
  LIBS
    ecflow_all
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
)
target_clangformat(ecflow_client)

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_client
  PROPERTIES
    INSTALL_RPATH ""
)



# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)


# ================================================================================                         
# TEST
set(test_srcs
  # Headers
  test/InvokeServer.hpp
  # Sources
  test/TestClient_main.cpp # test entry point
  test/TestClientConfigurations.cpp
  test/TestClientEnvironment.cpp
  test/TestClientOptions.cpp
  test/TestClientInterface.cpp
  test/TestJobGenOnly.cpp
  test/TestLifeCycle.cpp
  test/TestInitAddVariables.cpp
  test/TestRtt.cpp
  test/TestUrlCmd.cpp
)

if (ENABLE_SERVER)
  list(APPEND test_srcs
    # Headers
    test/SCPort.hpp
    # Sources
    test/SCPort.cpp
    test/TestClientTimeout.cpp
    test/TestClientHandleCmd.cpp
    test/TestCheckPtDefsCmd.cpp
    test/TestCustomUser.cpp
    test/TestGroupCmd.cpp
    test/TestLoadDefsCmd.cpp
    test/TestLogAndCheckptErrors.cpp
    test/TestPasswdFile.cpp
    test/TestPlugCmd.cpp
    test/TestServer.cpp
    test/TestServerAndLifeCycle.cpp
    test/TestServerLoad.cpp
    test/TestSignalSIGTERM.cpp
    test/TestWhiteListFile.cpp
  )
endif()

ecbuild_add_test(
  TARGET
    s_client
  LABELS
    integration nightly
  SOURCES
    ${test_srcs}
  INCLUDES
    ../base/test
    ../node/test
  LIBS
    ecflow_all
    test_scaffold
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    Boost::timer
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
  DEPENDS
    ecflow_server # the server is launched to support tests
  TEST_DEPENDS
    u_base
  CONDITION
    ENABLE_SERVER # AND ENABLE_TESTS
)
target_clangformat(s_client
  CONDITION ENABLE_SERVER AND ENABLE_TESTS
)

if (ENABLE_ALL_TESTS AND ENABLE_SERVER)
  #
  # Simple stand alone test
  #
  ecbuild_add_test(
    TARGET
      p_large_defs
    LABELS
      performance
      manual # requires manual definition of env var ECF_TEST_DEFS_DIR
    SOURCES
      # Headers
      test/SCPort.hpp
      # Sources
      test/SCPort.cpp
      test/TestSinglePerf.cpp
      test/TestSinglePerf_main.cpp # test entry point
    INCLUDES
      ../base/test
    LIBS
      ecflow_all
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    DEPENDS
      ecflow_server # the server is launched to support tests
    TEST_DEPENDS
      u_base
  )
  target_clangformat(p_large_defs
    CONDITION ENABLE_TESTS
  )

  #
  # test migration
  #
  ecbuild_add_test(
    TARGET
      m_migration
    LABELS
      migration
      manual # requires command line argument: m_test_migration <>
    SOURCES
      # Headers
      test/SCPort.hpp
      # Sources
      test/SCPort.cpp
      test/TestMigration.cpp
      test/TestMigration_main.cpp # test entry point
    INCLUDES
      ../base/test
    LIBS
      ecflow_all
      Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    DEPENDS
      ecflow_server # the server is launched to support tests
    TEST_DEPENDS
      u_base
  )
  target_clangformat(m_migration
    CONDITION ENABLE_TESTS
  )

endif()

# ===================================================================
# install
# ===================================================================
install (TARGETS ecflow_client DESTINATION bin)

=== libs/core/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

##
## Notice: test_support is an INTERFACE-only test utility library.
##

ecbuild_add_library(
  TARGET
    test_scaffold
  NOINSTALL
  TYPE INTERFACE
  SOURCES
    test/scaffold/ecflow/test/scaffold/Provisioning.hpp
    test/scaffold/ecflow/test/scaffold/Serialisation.hpp
  PUBLIC_INCLUDES
    test/scaffold
)
target_clangformat(test_scaffold)

set(test_srcs
  # Headers
  test/TestVersioning.hpp
  # Sources
  test/TestCalendar.cpp
  test/TestCereal.cpp
  test/TestCerealOptionalNVP.cpp
  test/TestCerealWithHierarchy.cpp
  test/TestChrono.cpp
  test/TestClassDataMemberInit.cpp
  test/TestCommandLine.cpp
  test/TestCore_main.cpp # contains main() function for test driver
  test/TestExtract.cpp
  test/TestFile.cpp
  test/TestGetUserDetails.cpp
  test/TestLog.cpp
  test/TestMessage.cpp
  test/TestMigration.cpp
  test/TestNodePath.cpp
  test/TestPasswdFile.cpp
  test/TestPasswordEncryption.cpp
  test/TestPerfTimer.cpp
  test/TestRealCalendar.cpp
  test/TestSanitizerAS.cpp
  test/TestSanitizerUB.cpp
  test/TestSerialisation.cpp
  test/TestStr.cpp
  test/TestStringSplitPerf.cpp
  test/TestStringSplitter.cpp
  test/TestTimeSeries.cpp
  test/TestTimeSlot.cpp
  test/TestVersion.cpp
  test/TestVersioning.cpp
  test/TestWhiteListFile.cpp
)

ecbuild_add_test(
  TARGET
    u_core
  LABELS
    unit
    nightly
  SOURCES
    ${test_srcs}
  LIBS
    ecflow_all
    test_scaffold
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    Boost::timer
)
target_clangformat(u_core
  CONDITION ENABLE_TESTS
)

=== libs/rest/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# cpp-httplib requires at least OpenSSL 1.1.1 for https support
# so if we have OpenSSL enabled and the version is less than this,
# we should disable SSL capabilities from the HTTP server

if (OPENSSL_FOUND)
  if (OPENSSL_VERSION VERSION_LESS 1.1.1)
    ecbuild_warn("HTTP_SERVER requires at least OpenSSL 1.1.1 for https support (have version ${OPENSSL_VERSION}) - disabling https in HTTP server")
    remove_definitions(-DECF_OPENSSL)
    set(DISABLED_SSL_IN_HTTP_SERVER 1)
  endif ()
endif ()

set(srcs
  # Headers
  src/ecflow/http/Api.hpp
  src/ecflow/http/ApiV1.hpp
  src/ecflow/http/ApiV1Impl.hpp
  src/ecflow/http/Base64.hpp
  src/ecflow/http/BasicAuth.hpp
  src/ecflow/http/Client.hpp
  src/ecflow/http/DefsStorage.hpp
  src/ecflow/http/HttpServer.hpp
  src/ecflow/http/HttpServerException.hpp
  src/ecflow/http/JSON.hpp
  src/ecflow/http/Options.hpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/http/TokenStorage.hpp>
  src/ecflow/http/TreeGeneration.hpp
  src/ecflow/http/TypeToJson.hpp
  # Sources
  src/ecflow/http/Api.cpp
  src/ecflow/http/ApiV1.cpp
  src/ecflow/http/ApiV1Impl.cpp
  src/ecflow/http/BasicAuth.cpp
  src/ecflow/http/Client.cpp
  src/ecflow/http/DefsStorage.cpp
  src/ecflow/http/HttpServer.cpp
  src/ecflow/http/JSON.cpp
  src/ecflow/http/Options.cpp
  src/ecflow/http/TypeToJson.cpp
  $<$<BOOL:${OPENSSL_FOUND}>:src/ecflow/http/TokenStorage.cpp>
)

ecbuild_add_library(
  TARGET libhttp
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
  PUBLIC_LIBS
    ecflow_all
    nlohmann::json
    httplib::httplib
    $<$<BOOL:${ZLIB_FOUND}>:ZLIB::ZLIB>
  PUBLIC_DEFINITIONS
    $<$<BOOL:${ZLIB_FOUND}>:ECF_HTTP_COMPRESSION>
)
target_clangformat(libhttp)

# ========================================================================
# EXE ecflow_http, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable(
  TARGET ecflow_http
  SOURCES
    src/ecflow/http/HttpMain.cpp
  LIBS
    libhttp
    ecflow_all
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
)
target_clangformat(ecflow_http)

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_http
  PROPERTIES
  INSTALL_RPATH ""
)

# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

if (ENABLE_HTTP AND ENABLE_SERVER)

  if (OPENSSL_FOUND AND NOT DISABLED_SSL_IN_HTTP_SERVER)

    set(test_srcs
      # Headers
      test/Certificate.hpp
      test/InvokeServer.hpp
      test/TokenFile.hpp
      # Sources
      test/TestApiV1.cpp
      test/TestHttp_main.cpp # test entry point
    )

    ecbuild_add_test(
      TARGET
        s_http
      LABELS
        integration nightly
      SOURCES
        ${test_srcs}
      INCLUDES
        ../base/test
      LIBS
        libhttp
        ecflow_all
        Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
        $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
      DEPENDS
        ecflow_server # the server is launched to support tests
        ecflow_http
      TEST_DEPENDS
        u_base
        s_client
    )
    target_clangformat(s_http
      CONDITION ENABLE_TESTS
    )
  else ()
    message(WARNING "SSL not enabled - will not run HTTP server tests")
  endif ()

endif ()

# ===================================================================
# install
# ===================================================================
install(TARGETS ecflow_http DESTINATION bin)

=== libs/server/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# =======================================================
# EXE ecflow_server, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable(
  TARGET
    ecflow_server
  SOURCES
    src/ecflow/server/ServerMain.cpp
  LIBS
    ecflow_all
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    Threads::Threads
)
target_clangformat(ecflow_server)

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_server
  PROPERTIES
    INSTALL_RPATH ""
)

# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

                          
# ================================================================================                         
# TEST
ecbuild_add_test(
  TARGET
    u_server
  LABELS
    unit nightly
  INCLUDES
    src
  SOURCES
    test/TestCheckPtSaver.cpp
    test/TestServerConfigurations.cpp
    test/TestServerEnvironment.cpp
    test/TestServer_main.cpp # test entry point
    test/TestServer.cpp
  LIBS
    ecflow_all
    test_scaffold
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    Threads::Threads
  TEST_DEPENDS
    u_base
)

target_clangformat(u_server CONDITION ENABLE_TESTS)

# ================================================================================
# TEST
ecbuild_add_test(
  TARGET
    s_periodic_scheduler
  LABELS
    integration nightly
  INCLUDES
    src
  SOURCES
    test/TestPeriodicScheduler.cpp
    test/TestPeriodicScheduler_main.cpp # test entry point
  LIBS
    ecflow_all
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    Threads::Threads
  TEST_DEPENDS
    u_base
)

target_clangformat(s_periodic_scheduler CONDITION ENABLE_TESTS)

# ===================================================================
# install
# ===================================================================
install (TARGETS ecflow_server DESTINATION bin)

=== libs/service/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

# ecflow_services
# --------------------------------------------------

# u_service_executor
# --------------------------------------------------

ecbuild_add_test(
  TARGET
    u_service_executor
  LABELS
    unit nightly
  SOURCES
    # Sources
    test/executor/TestExecutor_main.cpp # test entry point
    test/executor/TestPeriodicTaskExecutor.cpp
  LIBS
    ecflow_all
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
)
target_clangformat(u_service_executor
  CONDITION ENABLE_TESTS
)

# u_service_auth
# --------------------------------------------------

ecbuild_add_test(
  TARGET
    u_service_auth
  LABELS
    unit nightly
  SOURCES
    # Headers -- utilities
    test/TestContentProvider.hpp
    # Sources -- utilities
    test/TestContentProvider.cpp
  # Sources
    test/auth/TestAuth_main.cpp # test entry point
    test/auth/TestAuth.cpp
  INCLUDES
    test
  LIBS
    ecflow_all
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    Boost::filesystem
)
target_clangformat(u_service_auth
  CONDITION ENABLE_TESTS
)

# u_service_aviso
# --------------------------------------------------

ecbuild_add_test(
  TARGET
    u_service_aviso
  LABELS
    unit nightly
  SOURCES
    # Headers -- utilities
    test/TestContentProvider.hpp
    # Sources -- utilities
    test/TestContentProvider.cpp
    # Sources
    test/aviso/TestAviso_main.cpp # test entry point
    test/aviso/TestAviso.cpp
    test/aviso/TestAvisoService.cpp
  INCLUDES
    test
  LIBS
    ecflow_all
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
    Boost::filesystem
)
target_clangformat(u_service_aviso
  CONDITION ENABLE_TESTS
)

# u_service_mirror
# --------------------------------------------------

ecbuild_add_test(
  TARGET
    u_service_mirror
  LABELS
    unit nightly
  SOURCES
    # Sources
    test/mirror/TestMirror_main.cpp # test entry point
    test/mirror/TestMirror.cpp
    test/mirror/TestMirrorClient.cpp
    test/mirror/TestMirrorService.cpp
  LIBS
    ecflow_all
    Boost::boost # Boost header-only libraries must be available (namely unit_test_framework)
)
target_clangformat(u_service_mirror
  CONDITION ENABLE_TESTS
)

=== libs/test/CMakeLists.txt ===
#
# Copyright 2009- ECMWF.
#
# This software is licensed under the terms of the Apache Licence version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

set(srcs
  # Headers
  src/ServerTestHarness.hpp
  src/TestFixture.hpp
  src/ZombieUtil.hpp
  # Sources
  src/ServerTestHarness.cpp
  src/TestFixture.cpp
  src/ZombieUtill.cpp
)

ecbuild_add_library(
  TARGET
    libharness
  NOINSTALL
  TYPE STATIC
  SOURCES
    ${srcs}
  PUBLIC_INCLUDES
    src
    ../base/test
  PUBLIC_LIBS
    ecflow_all
)
target_clangformat(libharness)

# =================================================================
# test

if (ENABLE_ALL_TESTS)

  set(test_srcs
    Test_main.cpp # test entry point
    TestAbortCmd.cpp
    TestAlias.cpp
    TestClkSync.cpp
    TestComplete.cpp
    TestCron.cpp
    TestCtsWaitCmd.cpp
    TestDayDate.cpp
    TestEcfNoScriptCmd.cpp
    TestEcfScriptCmd.cpp
    TestEvents.cpp
    TestFileCmd.cpp
    TestHandle.cpp
    TestInitAddVariable.cpp
    TestKillCmd.cpp
    TestLate.cpp
    TestLimit.cpp
    TestOrderCmd.cpp
    TestQueueCmd.cpp
    TestRepeat.cpp
    TestRequeueNode.cpp
    TestServer.cpp
    TestSpecificIssues.cpp
    TestSuspend.cpp
    TestTime.cpp
    TestToday.cpp
    TestTrigger.cpp
    TestWhyCmd.cpp
  )

  ecbuild_add_test(
    TARGET
      s_test
    LABELS
      integration
      nightly
    SOURCES
      ${test_srcs}
    LIBS
      libharness
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    TEST_DEPENDS
      s_client
  )
  target_clangformat(s_test CONDITION ENABLE_TESTS)

  ecbuild_add_test(
    TARGET
      s_zombies
    LABELS
      integration
      nightly
    SOURCES
      TestZombies.cpp
      TestZombies_main.cpp # test entry point
    LIBS
      libharness
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    TEST_DEPENDS
      s_test
  )
  target_clangformat(s_zombies CONDITION ENABLE_TESTS)

  # This test runs forever, hence not suitable as unit test.
  ecbuild_add_test(
    TARGET
      s_single
    LABELS
      integration
      manual
    SOURCES
      TestSingle.cpp
      TestSingle_main.cpp # test entry point
    LIBS
      libharness
      $<$<BOOL:${OPENSSL_FOUND}>:OpenSSL::SSL>
    TEST_DEPENDS
      s_client
  )
  target_clangformat(s_single CONDITION ENABLE_TESTS)

endif()

=== debian/changelog ===
ecflow (5.13.8-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:28:08 +0200

ecflow (5.13.8-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 22 Mar 2025 09:19:42 +0000

=== debian/control ===
Source: ecflow
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-sequence-python3, 
  python3-all-dev,
  ecbuild (>= 3.3.0-3),
  doxygen,
  chrpath, 
  libmotif-dev, 
  libxpm-dev,
  libssl-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  qt6-charts-dev,
  libqt6opengl6-dev,
  libxkbcommon-dev,
  libboost-test-dev, 
  libboost-serialization-dev,
  libboost-date-time-dev, 
  libboost-timer-dev,
  libboost-chrono-dev,
  libboost-thread-dev,
  libboost-regex-dev, 
  libboost-python-dev (>= 1.71.0-7+b1), 
  libboost-program-options-dev, libboost-filesystem-dev
Standards-Version: 4.7.2
Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
Vcs-Browser: https://salsa.debian.org/science-team/ecflow.git
Vcs-Git: https://salsa.debian.org/science-team/ecflow.git -b debian/latest


Package: ecflow-server
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh
Description: Meteorological workflow controller - server 
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.


Package: ecflow-client
Architecture: any
Depends: ${misc:Depends},${shlibs:Depends}, libqt6svg6, ${python3:Depends}, python3-fuse
Description: Client tools for Meteorological workflow
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.
 .
 This package contains the client tools

Package: python3-ecflow
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-fuse
Description: Python3 libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python3 modules used in writing ecflow scripts.

=== debian/tests/control ===
Test-Command: set -e
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import ecflow"
 ; done
Depends: python3-ecflow, python3-all

Test-Command: ecflow_client --help
Depends: ecflow-client
